; 22. feladat:
; rjon egy olyan programot, amely a 7AF2H rtket kirja a kpernyre oktlisan,
; decimlisan s hexadecimlisan!


.286
ADAT	SEGMENT
MINTA	DW	7AF2H
DOKT	DB	6 DUP(?)		; 6 jegy ASCII kd szm (max. 177777)
DDEC	DB	5 DUP (?)		; 5 jegy ASCII kd szm (max. 65535)
DHEX	DB	4 DUP(?)		; 4 bjt (4 ASCII karakter)

NYOLC	 DW	8
TIZ	 DW	10
TIZENHAT DW	16
ADAT	ENDS

VEREM	SEGMENT STACK
	DW	20 DUP (?)
VEREM	ENDS



KOD	SEGMENT
	ASSUME	DS:ADAT, CS:KOD


;--------------------------------------
BIN2HEX	PROC			; A Procedura a DH-ban lv binris szmot konvertlja 2 db ASCII Hex szmjegyre
				; s elmenti a DHEX trhelyre
	MOV	CX, 2
KONV:	ROL 	DH, 4		; a fels 4 biten lv rtk (1. szmjegy) mozgatsa az als ngy bitre
	MOV	DL, DH		; a DL-ben dolgozunk
	AND	DL, 0FH		; als 4 bit (1. szmjegy) maszkolsa
	CMP	DL, 9		; 1. szmjegy <= 9 ?
	JNG	DECIM
	ADD	DL, 7		; ha a szmjegy A-F kztti, akkor a zna= 37H)
DECIM:	ADD	DL, 30H		; znarsz hozzadsa
	MOV	DHEX[DI], DL	; ments
	INC	DI
	LOOP	KONV		; kvetkez szmjegy

	RET
BIN2HEX	ENDP
;--------------------------------------
UJSOR	MACRO
	MOV	AH, 2
	MOV	DL, 0DH		; (CR)
	INT	21H
	MOV	DL, 0AH		; (LF)
	INT	21H
	ENDM
;--------------------------------------



START:	MOV	AX, ADAT
	MOV	DS, AX

	;------------- konvertls hexadecimlisra ----------
	MOV	BX, MINTA
	MOV	DI, 0
	MOV	DH, BH
	CALL	BIN2HEX
	MOV	DH, BL
	CALL	BIN2HEX

	;------------- konvertls decimlisra -----------
	MOV	AX,MINTA		; ezt kell konvertlni
	MOV	SI,4			; index az utols memriarekeszhez a pufferben
	MOV	CX,5			; ciklusszmll belltsa
CIKL1:	MOV	DX,0			; szavas osztshoz
	DIV 	TIZ			; szavas osztst hajtunk vgre, mert bjtos osztsnl a hnyados is bjton keletkezik
	OR	DL,30H			; znarsz hozzadsa a maradkhoz
	MOV	DDEC[SI], DL		; maradk (szmjegy) trolsa
	DEC	SI
	LOOP	CIKL1

	;------------- konvertls oktlisra -----------
	MOV	AX,MINTA		; ugyamaz, mint a decimlis konverzi, csak most
	MOV	SI,5			; 8-al kell osztani. (maradk a szmjegy)
	MOV	CX,6			; az eredmnyt pedig tovbb kell osztani
CIKL2:	MOV	DX,0			
	DIV 	NYOLC			
	OR	DL,30H			
	MOV	DOKT[SI], DL		
	DEC	SI
	LOOP	CIKL2



	;------------- konvertls oktlisra -----------
	; ???

	
	MOV	AH, 2
	MOV	CX, 4		; hexa kiirsa
	MOV	DI, 0
KIIR1:	MOV	DL, DHEX[DI]
	INT	21H
	INC	DI
	LOOP KIIR1

	UJSOR			; makr hvsa

	MOV	CX, 5		; decimlis kiirsa
	MOV	DI, 0
KIIR2:	MOV	DL, DDEC[DI]
	INT	21H
	INC	DI
	LOOP KIIR2

	UJSOR			; makr hvsa

	MOV	CX, 6		; oktlis kiirsa
	MOV	DI, 0
KIIR3:	MOV	DL, DOKT[DI]
	INT	21H
	INC	DI
	LOOP KIIR3



	;---------------------------
	MOV	AH, 4CH		; kilps
	INT	21H

KOD	ENDS
	END	START

